<script setup lang="ts">
const props = withDefaults(
  defineProps<{
    name: string;
    description?: string;
    noAction?: boolean;
    disabled?: boolean;
    selected?: boolean;
  }>(),
  {
    description: "No description",
    noAction: false,
    disabled: false,
    selected: false,
  },
);

const { name, description, noAction, disabled, selected } = toRefs(props);

const emit = defineEmits<{
  (e: "icon-click"): void;
}>();

const label = computed(() => name.value.replace("->", "\u2192"));
</script>

<template>
  <v-tooltip color="primary" location="top" :disabled="selected">
    <template #activator="{ props: tooltipProps }">
      <v-chip
        v-bind="tooltipProps"
        label
        :variant="selected ? 'tonal' : 'outlined'"
        color="primary"
        :disabled="disabled"
        @click="noAction || emit('icon-click')"
      >
        <span>{{ label }}</span>
        <v-icon v-if="!noAction" end>{{
          selected ? "mdi-close-box" : "mdi-plus-box"
        }}</v-icon>
      </v-chip>
    </template>
    <span>{{ description }}</span>
  </v-tooltip>
</template>
